{$S-} {$R-} {$Q-}
{ Stack    checking OFF
  Range    checking OFF
  Overflow checking OFF }
unit graphu;
interface
uses graph;
var
   apage,vpage:byte;
   asp:single;

procedure r_line(x1,y1,x2,y2:single);
procedure r_rectangle(x1,y1,x2,y2:single);
procedure r_circle(x,y,rad:single);
procedure r_floodfill(x,y,renk:single);

procedure setapage(x:byte);
procedure setvpage(x:byte);
procedure copypage(src,dest:byte);
procedure screenswap;
procedure cls;

procedure get(x1,y1,x2,y2:integer;var bob:pointer);
procedure savegraf(s:string;x1,y1,x2,y2:integer);
procedure loadgraf(s:string;var bob);

procedure setrgbpalette(x,r,g,b:byte);
procedure getrgbpalette(x:byte;var r,g,b:byte);
procedure savepal(s:string);
procedure loadpal(s:string;var ptype:palettetype);

procedure print(s:string);
procedure printxy(x,y:integer;s:string);
procedure gets(x:string;var s:string);

procedure initsvga256(m:integer;s:string);
procedure herkulmod;

procedure waitvbl;


implementation
uses crt,dosya;

procedure r_line;
begin
line(round(x1),round(y1),round(x2),round(y2));
end;

procedure r_rectangle;
begin
rectangle(round(x1),round(y1),round(x2),round(y2));
end;

procedure r_circle;
begin
circle(round(x),round(y),round(rad));
end;

procedure r_floodfill;
begin
floodfill(round(x),round(y),round(renk));
end;

procedure setapage(x:byte);
begin
apage:=x;
setactivepage(x);
end;

procedure setvpage(x:byte);
begin
vpage:=x;
setvisualpage(x);
end;

procedure copypage(src,dest:byte);
var
   e0,e1:pointer;
begin
if src=0 then
begin
  e0:=ptr($b000,0);
  e1:=ptr($b800,0);
end
else
begin
  e0:=ptr($b800,0);
  e1:=ptr($b000,0);
end;
move(e0^,e1^,32000);
end;

procedure screenswap;
var
   eskipage:byte;
begin
eskipage:=vpage;
setvpage(apage);
setapage(eskipage);
end;

procedure cls;
var
   p:pointer;
begin
if apage=0 then p:=ptr($b000,0) else p:=ptr($b800,0);
fillchar(p^,32700,#0);
end;

procedure get(x1,y1,x2,y2:integer;var bob:pointer);
begin
getmem(bob,imagesize(x1,y1,x2,y2));
getimage(x1,y1,x2,y2,bob^);
end;

procedure savegraf(s:string;x1,y1,x2,y2:integer);
var
   p:pointer;
   f:file;
   size:word;
begin
size:=imagesize(x1,y1,x2,y2);
getmem(p,size);
getimage(x1,y1,x2,y2,p^);
assign(f,s);
rewrite(f,size);
blockwrite(f,p^,1);
close(f);
freemem(p,size);
end;

procedure loadgraf(s:string;var bob);
var
   f:file;
   b:byte;
begin
assign(f,s);
{$i-}
reset(f,1);
{$i+}
b:=ioresult;
if b<>0 then print('HATA ('+_str(b,false)+')')
else
begin
  blockread(f,bob,filesize(f));
  close(f);
end;
end;

procedure setrgbpalette(x,r,g,b:byte);
begin
port[$3c8]:=x;
port[$3c9]:=r;
port[$3c9]:=g;
port[$3c9]:=b;
end;

procedure getrgbpalette(x:byte;var r,g,b:byte);
begin
port[$3c7]:=x;
r:=port[$3c9];
g:=port[$3c9];
b:=port[$3c9];
end;

procedure savepal(s:string);
var
   f:file;
   p:palettetype;
begin
assign(f,s);
rewrite(f,1);
getpalette(p);
blockwrite(f,p,sizeof(p));
close(f);
end;

procedure loadpal(s:string;var ptype:palettetype);
var
   f:file;
   b:byte;
begin
assign(f,s);
{$i-}
reset(f,1);
{$i+}
blockread(f,ptype,sizeof(ptype));
getpalette(ptype);
close(f);
end;

procedure printxy(x,y:integer;s:string);
var
   fillinfo:fillsettingstype;
   textinfo:textsettingstype;
   g,h:integer;
   xkats,ykats:single;
begin
getfillsettings(fillinfo);
gettextsettings(textinfo);
setfillstyle(1,0);
case textinfo.horiz of
     centertext:xkats:=0.5;
     lefttext:xkats:=1;
     righttext:xkats:=0;
end;
case textinfo.vert of
     centertext:ykats:=0.5;
     toptext:ykats:=1;
     bottomtext:ykats:=0;
end;
g:=textwidth(s);
h:=textheight(s);
bar(x+round(g*xkats),y+round(h*ykats),x+round(g*xkats)-g,y+round(h*ykats)-h);
outtextxy(x,y,s);
setfillstyle(fillinfo.pattern,fillinfo.color);
end;

procedure print(s:string);
begin
printxy(getx,gety,s);
end;

procedure gets(x:string;var s:string);
var
   cizgi:boolean;
   t:single;
   tus:char;
   sonharf:char;
begin
print(x);
moveto(getx+textwidth(x),gety);
s:='';
repeat
  repeat
    if (timer-t>0.15) and cizgi then
    begin
      printxy(getx,gety,'_');
      t:=timer;
      cizgi:=false;
    end;
    if (timer-t>0.15) and not cizgi then
    begin
      printxy(getx,gety,' ');
      t:=timer;
      cizgi:=true;
    end;
  until keypressed;
  tus:=readkey;
   if tus=#8 then
             begin
               if length(s)>0 then
               begin
                 printxy(getx-textwidth(sonharf),gety,'  ');
                 moveto(getx-textwidth(sonharf),gety);
                 s:=copy(s,1,length(s)-1);
               end;
             end
             else if tus in [' '..#127] then
             begin
               print(tus);
               sonharf:=tus;
               s:=s+tus;
               moveto(getx+textwidth(tus),gety);
             end;
until tus=#13;
end;

{$F+}
procedure initsvga256(m:integer;s:string);
var
  maxx,maxy,Driver, Mode, TestDriver,
  ErrCode  : Integer;

function TestDetect : Integer;
{ Autodetect function. Assume hardware is
  always present. Return value = recommended
  default mode. }
begin
  TestDetect := 0;
end;

{$F-}

begin
  { Install the driver }
  TestDriver :=InstallUserDriver('svga256', @TestDetect);
  if GraphResult <> grOk then
  begin
    WriteLn('Error installing TestDriver');
    Halt(1);
  end;
  Driver := Detect;
  InitGraph(Driver, Mode, s);
  setgraphmode(m);
end;


procedure herkulmod;
var
   gd,gm:integer;
begin
gd:=7;
gm:=0;
initgraph(gd,gm,'');
asp:=0.75;
end;

procedure waitvbl;
begin
repeat until port[$3da] and 8 = 8;
end;

begin
apage:=0;
vpage:=0;
end.


be  .  }
write('Speed of Bar #2:');      {    .  .  .  }
readln(k2);                     {    .  .  .  }
getintvec($9,@vect1);           {    .  .  .  }
setintvec($9,addr(keyclick));   {    .  .  .  }
asp:=0.75;                      {    .  .  .  }
detectgraph(gd,gm);             {    .  .  .  }
if gd<>hercmono then begin      {    .  .  .  }
                     writeln('Bu oyun yalnz HERCULES grafik kartyla alsr');
                     halt(1);
                     end;

initgraph(gd,gm,'');
detectgraph(gd,gm);
circle(300,200,rad);
setfillstyle(11,1);
floodfill(300,200,1);
getmem(top,imagesize(round(300-rad),round(200-rad*asp),round(300+rad),round(200+rad*asp)));
getmem(cu1,imagesize(0,0,xg1,yg1));
getmem(cu2,imagesize(0,0,xg2,yg2));
getimage(round(300-rad),round(200-rad*asp),round(300+rad),round(200+rad*asp),top^);
cleardevice;
setfillstyle(4,1);
bar(0,0,xg1,yg1);
setfillstyle(1,1);
getimage(0,0,xg1,yg1,cu1^);
bar(100,100,100+xg2,100+yg2);
getimage(100,100,100+xg2,100+yg2,cu2^{$M 20000,0,655360}

uses crt,dos,graph,graphu,keybu,mat,dosya,crtu;
const
     maxbalon=15;
label
     basla,cikis;
var
   p:pointer;
   balon:array[1..maxbalon] of record
                        varlik:boolean;
                        spacebasildi:boolean;
                        xkor,ykor:single;
                        ykorbas:single;
                        xkore,ykore:single;
                        hizx:single;
                        hizy:single;
                        hizybas:single;
                        bob:array[1..1000] of byte;
                        xyon,yyon:shortint;
                        deltat:single;
                        xge,yge:byte;
                        end;
   max:single;
   t,tkoruma:single;
   tus:char;
   hepsivuruldu:boolean;
   spacebasildi:boolean;
   xtop:integer;
   xtope:integer;
   xkoruma,xkorumae:integer;
   xok,yok:integer;
   xoke,yoke:integer;

   g:single;
   step:single;
   ok:array[1..1000] of byte;
   atici:array[1..1300] of byte;
   dinamit:array[1..1000] of byte;
   kutu:array[1..1000] of byte;
   koruma:array[1..1000] of byte;
   j,ii,k:integer;
   hak:byte;
   kvar,korumavar:boolean;

procedure bitti;
begin
play('2ee6g');
settextstyle(3,horizdir,5);
settextjustify(centertext,centertext);
outtextxy(getmaxx div 2,getmaxy div 2,'Blm 1 : BITTI');
screenswap;
repeat until keypressed;
end;

procedure yandi;
var
   i:integer;
begin

for i:=1 to 500 do sound(round(random*1000+i));
nosound;

putimage(hak*35,1,dinamit,xorput);
screenswap;
putimage(hak*35,1,dinamit,xorput);
screenswap;
hak:=hak-1;
end;

procedure cing;
var
   i:integer;
begin
for i:=500 to 2000 do sound(i);
nosound;
end;

procedure din;
var
   i:integer;
begin
for i:=100 to 600 do sound(i);
nosound;
end;

procedure bang;
var
   i:integer;
begin
  for i:=300 to 350 do
  begin
    sound(i);
  end;
  for i:=3300 to 3700 do
  begin
    sound(i);sound(i-3200);
  end;
  nosound;
end;

procedure diyuv;
var
   i:integer;
begin
  for i:=700 downto 200 do sound(i);
  nosound;
end;

procedure cizim;
begin
  putimage(xtop,303,atici,xorput);
  if korumavar then putimage(xtop-5,300,koruma,xorput);
  if spacebasildi then putimage(xok,yok,ok,xorput);
  for ii:=1 to maxbalon do with balon[ii] do
  begin
    if varlik then putimage(round(xkor),round(ykor),bob,xorput);
  end;
  waitvbl;
  waitvbl;
  screenswap;
  putimage(xt
