{$S-} {$R-} {$Q-}
{ Stack    checking OFF
  Range    checking OFF
  Overflow checking OFF }
unit mat;

interface
type
    _3dtipi=record x,y,z:single;end;
var
   _cos,_sin:array[0..360] of single;


procedure derece;

function fak(i:integer):single;
function sgn(x:single):shortint;
function us(x,y:single):single;
function dectobin(x:integer):string;
function bintodec(s:string):integer;

function arasinda(x,y,z:single):boolean;

function uzaklik(x1,y1,x2,y2:single):single;
function uzaklikbul(x,y,m,c:single):single;
procedure _2dmcbul(x1,y1,x2,y2:single;var m,c:single);
function _2dkesbulx(m1,c1,m2,c2:single):single;
function _2dkesbuly(m1,c1,m2,c2:single):single;
function _2dacibul(m1,m2:single):single;

procedure dkescbul(m,c,xm,ym,rd:single;var xkes1,xkes2:single);

procedure i_3to2(x,y,z,xgoz,ygoz,zgoz:integer;var xg,yg:integer);
procedure r_3to2(x,y,z,xgoz,ygoz,zgoz:single;var xg,yg:single);
procedure dondurx(var y,z:single;oriy,oriz:single;aci:integer);
procedure dondury(var x,z:single;orix,oriz:single;aci:integer);
procedure dondurz(var x,y:single;orix,oriy:single;aci:integer);

procedure duzlembul(x1,y1,z1,x2,y2,z2,x3,y3,z3:single;var a,b,c:single);
procedure dogduzkesbul(m1,c1,m2,c2,a,b,c:single;var n:_3dtipi);

implementation
uses dosya;

function fak(i:integer):single;
var
   j:integer;
   x:single;
begin;
x:=1;
for j:=1 to i do x:=x*j;
fak:=x;
if i=0 then fak:=1;
end;

procedure derece;
var
   i:integer;
   x:single;
begin
x:=pi/180;
for i:=0 to 360 do
begin
  _cos[i]:=cos(i*x);
  _sin[i]:=sin(i*x);
end;
end;

function sgn(x:single):shortint;
begin
sgn:=0;
if x>0 then
begin
  sgn:=1;
  exit;
end;
if x<0 then sgn:=-1;
end;

function us(x,y:single):single;
begin
if x=0 then us:=0 else us:=exp(y*ln(x));
end;

function dectobin(x:integer):string;
var
   s,s2:string;
   i:integer;
   bolum,kalan:integer;
begin
i:=255;
s:=#0;
repeat
  i:=i-1;
  bolum:=x div 2;
  kalan:=x mod 2;
  s2:=_str(kalan,false);
  s[i]:=s2[1];
  x:=bolum;
until bolum<2;
s2:=_str(bolum,false);
s[i+1]:=s2[1];
dectobin:=copy(s,pos('1',s),255-pos('1',s));
end;

function bintodec(s:string):integer;
var
   i:integer;
   sayi:longint;
begin
sayi:=0;
for i:=1 to length(s) do sayi:=sayi+round(us(2,length(s)-i)*_val(s[i],false));
bintodec:=sayi;
end;

function arasinda(x,y,z:single):boolean;
begin
arasinda:=false;
if ( (x>=y) and (x<=z) ) or ( (x<=y) and (x>=z) ) then arasinda:=true;
end;

function uzaklik(x1,y1,x2,y2:single):single;
begin
uzaklik:=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
end;

function uzaklikbul(x,y,m,c:single):single;
begin
uzaklikbul:=abs(m*x+y-c)/sqrt(m*m+1);
end;

procedure _2dmcbul(x1,y1,x2,y2:single;var m,c:single);
begin
m:=10000;
if abs(x1-x2)>0.0001 then m:=(y1-y2)/(x1-x2)
else begin
       m:=10000*sgn(y1-y2);
       if x1<x2 then m:=-m;
     end;
c:=y1-m*x1;
end;

function _2dkesbulx(m1,c1,m2,c2:single):single;
begin
_2dkesbulx:=(c2-c1)/(m1-m2);
end;

function _2dkesbuly(m1,c1,m2,c2:single):single;
begin
_2dkesbuly:=m1*_2dkesbulx(m1,c1,m2,c2)+c1;
end;

function _2dacibul(m1,m2:single):single;
begin
_2dacibul:=arctan(abs(m1-m2)/(1+m1*m2));
end;

procedure dkescbul(m,c,xm,ym,rd:single;var xkes1,xkes2:single);
var
   asayi,bsayi,csayi:single;
   disk:single;
begin
asayi:=1+m*m;
bsayi:=-2*xm+2*m*c-2*ym*m;
csayi:=c*c-2*ym*c+ym*ym-rd*rd+xm*xm;
disk:=bsayi*bsayi-4*asayi*csayi;

  xkes1:=-pi;
  xkes2:=pi;
if disk>=0 then
begin
  xkes1:=(-bsayi+sqrt(disk))/(2*asayi);
  xkes2:=(-bsayi-sqrt(disk))/(2*asayi);
end;
end;

procedure i_3to2(x,y,z,xgoz,ygoz,zgoz:integer;var xg,yg:integer);
begin
xg:=(x-xgoz) div (z-zgoz);
yg:=(y-ygoz) div (z-zgoz);
end;

procedure r_3to2(x,y,z,xgoz,ygoz,zgoz:single;var xg,yg:single);
begin
xg:=(x-xgoz)/(z-zgoz);
yg:=(y-ygoz)/(z-zgoz);
end;

procedure dondurx(var y,z:single;oriy,oriz:single;aci:integer);
var
   gecy:single;
begin
y:=y-oriy;
z:=z-oriz;
gecy:=y;
y:=y*_cos[aci]-z*_sin[aci];
z:=gecy*_sin[aci]+z*_cos[aci];
y:=y+oriy;
z:=z+oriz;
end;

procedure dondury(var x,z:single;orix,oriz:single;aci:integer);
var
   gecx:single;
begin
x:=x-orix;
z:=z-oriz;
gecx:=x;
x:=x*_cos[aci]-z*_sin[aci];
z:=gecx*_sin[aci]+z*_cos[aci];
x:=x+orix;
z:=z+oriz;
end;

procedure dondurz(var x,y:single;orix,oriy:single;aci:integer);
var
   gecx:single;
begin
x:=x-orix;
y:=y-oriy;
gecx:=x;
x:=x*_cos[aci]-y*_sin[aci];
y:=gecx*_sin[aci]+y*_cos[aci];
x:=x+orix;
y:=y+oriy;
end;

procedure duzlembul(x1,y1,z1,x2,y2,z2,x3,y3,z3:single;var a,b,c:single);
var
   u:single;
begin
u:=(y3-y1)/(y1-y2);
b:=((x3-x1)+(x2-x1)*u)/(z1-z3+(z1-z2)*u);
a:=(x2-x1-(z1-z2)*b)/(y1-y2);
c:=-x1-a*y1-b*z1;
end;

procedure dogduzkesbul(m1,c1,m2,c2,a,b,c:single;var n:_3dtipi);
begin
n.x:=(-a*c1-b*c2-c)/(1+a*m1+b*m2);
n.y:=m1*n.x+c1;
n.z:=m2*n.x+c2;
end;

begin
derece;
end.